// Copyright (C) 2008 panacoran <panacoran@users.sourceforge.jp>
// 
// This program is part of Protra.
//
// Protra is free software: you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, see <http://www.gnu.org/licenses/>.
// 
// $Id: Token.cs,v 1.1 2008-03-26 19:49:42 panacoran Exp $

namespace Protra.Lib.Lang
{
    /// <summary>
    /// ̌^\񋓌^B
    /// </summary>
    public enum TokenType
    {
        /// <summary>
        /// 
        /// </summary>
        Int,
        /// <summary>
        /// _
        /// </summary>
        Float,
        /// <summary>
        /// 
        /// </summary>
        String,
        /// <summary>
        /// [Jϐ̖O
        /// </summary>
        LocalVariable,
        /// <summary>
        /// O[oϐ̖O
        /// </summary>
        GlobalVariable,
        /// <summary>
        /// ֐̖O
        /// </summary>
        FunctionName,
        /// <summary>
        /// \
        /// </summary>
        Reserved,
        /// <summary>
        /// ^
        /// </summary>
        Type,
        /// <summary>
        /// Zq
        /// </summary>
        Operator,
        /// <summary>
        /// ̑
        /// </summary>
        Unknown,
        /// <summary>
        /// t@C̏I[
        /// </summary>
        EOF,
    }

    /// <summary>
    /// \NXB
    /// </summary>
    public class Token
    {
        TokenType type;
        int lineno;
        string filename;
        string value;
        int intValue;
        double floatValue;
        Token next;

        /// <summary>
        /// ̌^擾܂͐ݒ肷B
        /// </summary>
        public TokenType Type
        {
            get { return type; }
            set { type = value; }
        }

        /// <summary>
        /// sԍ擾܂͐ݒ肷B
        /// </summary>
        public int LineNo
        {
            get { return lineno; }
            set { lineno = value; }
        }

        /// <summary>
        /// t@C擾܂͐ݒ肷B
        /// </summary>
        public string Filename
        {
            get { return filename; }
            set { filename = value; }
        }

        /// <summary>
        /// \擾܂͐ݒ肷B
        /// </summary>
        public string Value
        {
            get { return value; }
            set { this.value = value; }
        }

        /// <summary>
        /// ̕\擾܂͐ݒ肷B
        /// </summary>
        public int IntValue
        {
            get { return intValue; }
            set { intValue = value; }
        }

        /// <summary>
        /// ̕\_擾܂͐ݒ肷B
        /// </summary>
        public double FloatValue
        {
            get { return floatValue; }
            set { floatValue = value; }
        }

        /// <summary>
        /// ̎擾܂͐ݒ肷B
        /// </summary>
        public Token Next
        {
            get { return next; }
            set { next = value; }
        }
    }
}
